\NeedsTeXFormat{LaTeX2e}
\ProvidesClass{currivitae} [2005/12/07 v0.1 Classe `currivitae']
%%%
%%% --------------------- Codi Inicial  ------------------------
%%%
\def\@format@de@currivitae{mcyt}
%
\def\@curristop{ \batchmode \@@end}
\gdef\currivitaeError#1{\GenericWarning{(currivitae) \space\@spaces\@spaces\@spaces}{%
      ! Class currivitae Error: #1.^^J^^J%
      See the currivitae class documentation for explanation.\@gobble%
   } \@curristop}
%%%
%%% --------------------- Declaracion i processamiento de opciones ---
%%%
\let\@escriu@contador\relax \newcount{\@item@numero}
\DeclareOption{habilitaciones}{\def\@format@de@currivitae{habilitaciones}}
\DeclareOption{mcyt}{\def\@format@de@currivitae{mcyt}}
\DeclareOption*{\PassOptionsToClass{\CurrentOption}{report}}
\ProcessOptions
\PassOptionsToClass{a4paper,11pt,final}{report}
\LoadClass{report}
%
% Especificaciones de la classe report para la classe currivitae
%
\nofiles
\setlength\parindent{0\p@}
\setlength\headheight{0\p@}
\setlength\headsep{0\p@}
\RequirePackage[latin1]{inputenc}
\RequirePackage{eurosym}
%%
%% Sistema de substituci del \begin{document} pel \begin{curri} i 
%% Escritura de Capsalera
%%
\def\@comandes@inicials@{\currivitaeError{\protect\begin{curri} replaces \protect\begin{document}}}
\newenvironment{curri}{%
  \global\def\@currenvir{curri}%
  \global\let\@comandes@inicials@\relax%
  \document}{\def\@currenvir{document}\enddocument}
\AtBeginDocument{%
  \@comandes@inicials@%
  \@@capsalera@curri \let\@@capsalera@curri\relax%
}
%%
%% Macros d'escriure sense mals talls de pagina
%%
\newlength{\@pagina} % Per controlar la mida del que portem escrit
\newsavebox{\@capsalera@apartat@text} % On guardem la capsalera per posar-la a cada pagina
\newsavebox{\@caixatmpa} % caixa temporal. Per mesurar el que volem imprimir.
% Comanda que carrega la capsalera amb el titol (parametre #1).
%      La macro  \@format@titol@comanda es dependent del format. Es defineix al corresponent
%      fitxer. sty.
\long\def\@capsalera@apartat#1{\@item@numero=0%
  \sbox{\@capsalera@apartat@text}{\parbox{\textwidth}{\@format@titol@comanda{#1}}}%
  \setlength{\@pagina}{\textheight}%
}
% Macro \@escriu@apartat@saltant@pagina@si@cal. Es la Macro sentral del sistema d'esc ritura
%  La macro  \@format@separacio es dependent del format. Es defineix al corresponent fitxer. sty.
\long\def\@escriu@apartat@saltant@pagina@si@cal#1{%
    \sbox{\@caixatmpa}{\parbox{\textwidth}{#1\@format@separacio}}\@@actualitzapagina{\@caixatmpa}%
    \ifdim\@pagina<\textheight\relax\else\@@escriu@capsalera\@@actualitzapagina{\@caixatmpa}\fi%
    \@escriu@contador\usebox{\@caixatmpa}\par\par%
}  % Fi de  \@escriu@apartat@saltant@pagina@si@cal
%  La macro  \@precapsalera@separacio es dependent del format. Es defineix al corresponent fitxer. sty.
\def\@@escriu@capsalera{%
   \@precapsalera@separacio \usebox{\@capsalera@apartat@text} \par\par%
   \setlength{\@pagina}{22pt}\@@actualitzapagina{\@capsalera@apartat@text}%
}
%
% Contador
%
\newcount{\@item@numero}
\def\SwitchContador{%
   \ifx\@escriu@contador\relax \@item@numero=0%
         \def\@escriu@contador{\advance\@item@numero by 1\relax%
              \setlength{\@tempdimc}{\dp\@caixatmpa}\addtolength{\@tempdimc}{-0.3ex}
              \leavevmode\kern -6em\raisebox{\@tempdimc}{\parbox{5.5em}{\hfill  \number\@item@numero\ --}}%
         \hspace{0.5em}%
         }
   \else \let\@escriu@contador\relax
   \fi
}
%%
%% Comandos de usuario
%%
% Control de escritura de cabeceras
\def\ApartadosConSaltoDePagina{\long\def\@precapsalera@separacio{\vspace*{\fill}\newpage}}
\def\ApartadosSinSaltoDePagina{\def\@precapsalera@separacio{}}
\def\CabeceraConstante{%
  \def\@@actualitzapagina##1{\global\advance\@pagina \ht##1\relax\global\advance\@pagina \dp##1\relax}
}
\def\CabeceraUnica{\def\@@actualitzapagina##1{}}
% Definiciones
\newcommand{\pts}{\texttt{pts\kern -1.5pt .}}
\newcommand{\DefineLetraFormulario}[1]{\gdef\@llet@form{#1}}
\newcommand{\DefineLetraTexto}[1]{#1}
\newcommand{\DefineOrigen}[2]{%
  \addtolength{\oddsidemargin}{#1}%
  \addtolength{\evensidemargin}{#1}%
  \addtolength{\topmargin}{#2}}
\def\DefineFecha#1{\gdef\@data{#1}}
\def\@data{\number\day\space de \ifcase\month\or Enero \or
  Febrero \or Marzo \or Abril \or Mayo \or Junio \or Julio \or Agosto
  \or Septiembre \or Octubre \or Noviembre \or Diciembre \fi
  de \number\year}
%
%\newcommand{\TextoLibre}[2][]{%
%  \ifx#1\empty\else\@capsalera@apartat{#1}\fi%
%\@escriu@apartat@saltant@pagina@si@cal{#2}%
%}
\newcommand{\TextoLibre}[2][]{%
  \ifx#1\empty\else 
     \@precapsalera@separacio \par\par
     \@format@titol@comanda{#1}
  \fi  \begingroup #2 \endgroup \@format@separacio 
}
%
% Generic Part of datos Personales
%
\def\DatosPersonales{% Principi de DadesPersonals
  \begingroup
  \def\Dato##1##2{\opcio@dada{Dato}{##1}{##2}}
  \def\opcio@dada##1##2##3{\@ifundefined{@@##2}{%
       \currivitaeError{Ilegal `##1' `##2'}}{%
       \expandafter\gdef\csname @@##2\endcsname{##3}}}
  \let\DatosPersonales\relax
} % Fi de DatosPersonales
\def\endDatosPersonales{\endgroup \let\endDatosPersonales\relax}
%
% Comandos de utilidad
%
%  La macro  \@itemestandar@separacio es dependent del format. Es defineix al corresponent.
%  fitxer. sty (veure l'apartat Formato variable de los apartados)
\newcommand{\LetraFormulario}[1]{{\@llet@form #1}}
\newcommand{\ItemEstandar}[2]{\LetraFormulario{#1:} #2 \par\par}
\newcommand{\ItemEstandarOpcional}[2]{\ifx#1\empty\else\ItemEstandar{#1}{#2}\fi}
%%
%% Macros de crear macros de apartados
%%
% #1 : apartado; #2 No. de parametros; #3: titulo; #4: Instrucciones; #5: Precomandos;
\long\def\DefineApartado#1[#2]#3#4#5{%
   \expandafter\new@command\csname #1@body\endcsname[#2]{\@escriu@apartat@saltant@pagina@si@cal{#4}}%
% Defining initialisation of #1 and redefining it to #1@body. Then executing (body already).
   \expandafter\gdef\csname #1\endcsname{#5\@capsalera@apartat{#3}%
         \expandafter\let\csname #1\expandafter\endcsname\csname #1@body\endcsname%
         \csname #1\endcsname%
   }%
} % End of \DefineApartado
%
% #1 : apartado; #2 :  titulo; #3: Apartado origen; #4: Precomandos;
\long\def\DefineApartadoDerivado#1#2#3#4{%
   \expandafter\gdef\csname #1\endcsname{#4\@capsalera@apartat{#2}%
         \expandafter\let\csname #1\expandafter\endcsname\csname #3@body\endcsname%
         \csname #1\endcsname%
   }%
} % End of \ApartadoDerivado
%
% Serie Ordenada d'apartats. CAL QUE ESTIGUIN INDEXADES CONSECUTIVAMENT d'1 endavant....
% (1,2,3,....)
%
\newcount{\@ordre@darrera@comanda}
\newcount{\@nombre@de@comandes@mi} \@nombre@de@comandes@mi=1 \relax
\def\@Llista@Ordenada@de@Comandes{}
%  #1 : No. de orden; #2 : apartado; #3: titulo; #4: Precomandos; #5: Postcomandos
\long\def\@Define@Titulo@de@Apartado@Ordenado@#1#2#3#4#5{%
   \g@addto@macro\@Llista@Ordenada@de@Comandes{\or #2}%
   \advance\@nombre@de@comandes@mi by 1 \relax%
   \expandafter\gdef\csname #2\endcsname{\@processa@apartat@anterior{#1} %
	 #4\@capsalera@apartat{#3} \@ordre@darrera@comanda=#1 \relax%
	 \@@escriu@capsalera#5%
         \expandafter\let\csname #2\expandafter\endcsname\relax%
   }%
} % End of \@Define@Titulo@de@Apartado@Ordenado@
%  #1 : No. de orden; #2 : apartado; #3 No. de parametros; #4: titulo; #5: Instrucciones; ; #6: Precomandos;
\long\def\@Define@Apartado@Ordenado@#1#2[#3]#4#5#6{%
   \expandafter\new@command\csname #2@body\endcsname[#3]{\@escriu@apartat@saltant@pagina@si@cal{#5}}%
   \g@addto@macro\@Llista@Ordenada@de@Comandes{\or #2}%
   \advance\@nombre@de@comandes@mi by 1 \relax%
   \expandafter\gdef\csname #2\endcsname{\@processa@apartat@anterior{#1} %
         #6\@capsalera@apartat{#4} \@ordre@darrera@comanda=#1 \relax%
         \expandafter\let\csname #2\expandafter\endcsname\csname #2@body\endcsname%
         \csname #2\endcsname%
   }%
} % End of \DefineApartadoOrdenado
%  #1 : No. de orden; #2 : apartado; #3 ; titulo; #4: : Apartado origen; #5: Precomandos;
\long\def\@Define@Apartado@Ordenado@Derivado#1#2#3#4#5{%
   \g@addto@macro\@Llista@Ordenada@de@Comandes{\or #2}%
   \advance\@nombre@de@comandes@mi by 1 \relax%
   \expandafter\gdef\csname #2\endcsname{\@processa@apartat@anterior{#1} %
         #5\@capsalera@apartat{#3} \@ordre@darrera@comanda=#1 \relax%
         \expandafter\let\csname #2\expandafter\endcsname\csname #4@body\endcsname%
         \csname #2\endcsname%
   }%
} % End of \DefineApartadoOrdenadoDerivado
\def\@processa@apartat@anterior#1{%
    \ifnum#1>1
       \@tempcnta=#1 \advance\@tempcnta by -1 \relax%
        \def\@nom@darrera@comanda{\ifcase\expandafter\@tempcnta\@Llista@Ordenada@de@Comandes\fi}
        \ifnum\@ordre@darrera@comanda<\@tempcnta
             \expandafter\csname \@nom@darrera@comanda\endcsname\empty\empty\empty\empty\empty\empty\empty\empty\empty
       \fi
        \expandafter\gdef\csname \@nom@darrera@comanda\endcsname{%
	  \currivitaeError{Comanda `\@nom@darrera@comanda' Fora d'ordre.}
	}
    \fi
} % Fi de \@processa@apartat@anterior
%
% The End: Defining defaults and loading the format
%
\DefineLetraFormulario{\sffamily}
\ApartadosConSaltoDePagina
\CabeceraConstante
\RequirePackage{\@format@de@currivitae}
\@ordre@darrera@comanda=0
\AtEndDocument{\@processa@apartat@anterior{\the\@nombre@de@comandes@mi}}
\endinput
